#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;

bool check(long long k) {
	if (k % 2 == 0)
		return false;
	for (long long i = 3; i * i <= k; i += 2) {
		if (k % i == 0) 
			return false;
	}
	return true;
}

long long solve_p(long long k) {
	long long ans = 1e18;
	for (long long i = 2; i * i <= k; i++) {
		if (k % i != 0)
			continue;
		long long j = k / i;
		if (abs(i + j) % 2 == 0)
			ans = min(ans, (i + j) / 2);
	}
	return ans;
}

long long solve_n(long long k) {
	long long ans = 1e18;
	for (long long i = 2; i * i <= k; i++) {
		if (k % i != 0)
			continue;
		long long j = k / i;
		if (abs(i + j) % 2 == 0)
			ans = min(ans, abs((i - j)) / 2);
	}
	return ans;
}

long long get(long long k) {
	if ((long long)sqrtl(abs(k)) * (long long)sqrt(abs(k)) == abs(k)) {
		if (k >= 0)
			return sqrtl(k);
		return 0;
	}
	if ((abs(k) - 2) % 4 == 0)
		return -1;
	if (check(abs(k))) {
		return abs(k + 1) / 2;
	}
	if (k >= 0)
		return solve_p(abs(k));
	return solve_n(abs(k));
	for (long long i = 0; i < 1e7; i++) {
		long long val = i * i + k;
		if (val < 0)
			continue;
		long long s = sqrtl(val);
		if (s * s == val) {
			return s;
		}
	}
	return -1;
}

int main() {
	long long k; cin >> k;
	long long got = get(k);
	if (got == -1) {
		cout << "none\n";
	} else {
		cout << got << endl;
	}
	//system("pause");
}