#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;

long long get(long long k) {
	for (long long i = 0; i < 1e8; i++) {
		long long val = i * i + k;
		if (val < 0)
			continue;
		long long s = sqrtl(val);
		if (s * s == val) {
			return s;
		}
	}
	return -1;
}

int main() {
	long long k; cin >> k;
	if ((abs(k) - 2) % 4 == 0) {
		cout << "none\n";
	} else {
		long long got = get(k);
		if (got == -1) {
			cout << "none\n";
		} else {
			cout << got << endl;
		}
	}
	//system("pause");
}