#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;

long long get(long long k) {
	if (k < 0 && (long long)sqrtl(-k) * (long long)sqrt(-k) == abs(k)) {
		return 0;
	}
	if ((abs(k) - 2) % 4 == 0)
		return -1;
	/*if (abs(k) % 3 == 1) {
		return (abs(k + 1)) / 2;
	}*/
	for (long long i = 0; i < 1e7; i++) {
		long long val = i * i + k;
		if (val < 0)
			continue;
		long long s = sqrtl(val);
		if (s * s == val) {
			return s;
		}
	}
	return -1;
}

int main() {
	/*for (int i = 0; i < 30; i++) {
		cout << i << ": " << get(i) << endl;
	}
	cout << "Okay\n";*/
	long long k; cin >> k;
	long long got = get(k);
	if (got == -1) {
		cout << "none\n";
	} else {
		cout << got << endl;
	}
	//system("pause");
}