#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
using namespace std;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, m; cin >> n >> m;
	vector<int> need(m);
	vector<int> a(n);
	for (int &x : need) {
		cin >> x;
		x--;
	}
	for (int &x : a) {
		cin >> x;
		x--;
	}
	vector<vector<int>> was(n);
	for (int i = 0; i < m; i++) {
		was[need[i]].push_back(i);
	}
	vector<int> ans;
	for (int cur = 0; cur < m; cur++) {
		while (true) {
			int x = a[0];
			auto got = lower_bound(was[x].begin(), was[x].end(), cur + 1);
			int now = (got == was[x].end() ? -1 : was[x][got - was[x].begin()]);
			vector<bool> used(n);
			int cnt = 0;
			for (int i = cur + 1; i < m; i++) {
				cnt += !used[need[i]];
				used[need[i]] = true;
				if (need[i] == x) {
					//now = i;
					break;
				}
			}
			cnt += !used[need[cur]];
			used[need[cur]] = true;
			if (now == -1) {
				a.erase(a.begin());
				a.push_back(x);
				ans.push_back(n);
			}
			else {
				for (int i = 0; i < n; i++) {
					cnt -= used[a[i]];
					used[a[i]] = false;
					if (cnt == 0) {
						ans.push_back(i + 1);
						if (i == n - 1)
							a.push_back(x);
						else
							a.insert(a.begin() + i + 1, x);
						a.erase(a.begin());
						break;
					}
				}
			}
			if (x == need[cur])
				break;
		}
	}
	cout << (int)ans.size() << endl;
	for (auto &x : ans) {
		cout << x << " ";
	}
	cout << endl;
	system("pause");
}