#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
using namespace std;

int n, m;

vector<int> a;
vector<int> need;

void solve_sq() {
	vector<int> ans;
	for (int cur = 0; cur < m; cur++) {
		while (true) {
			int x = a[0];
			int now = -1;
			vector<bool> used(n);
			int cnt = 0;
			for (int i = cur + 1; i < m; i++) {
				cnt += !used[need[i]];
				used[need[i]] = true;
				if (need[i] == x) {
					now = i;
					break;
				}
			}
			cnt += !used[need[cur]];
			used[need[cur]] = true;
			if (now == -1) {
				a.erase(a.begin());
				a.push_back(x);
				ans.push_back(n);
			}
			else {
				for (int i = 0; i < n; i++) {
					cnt -= used[a[i]];
					used[a[i]] = false;
					if (cnt == 0) {
						ans.push_back(i + 1);
						if (i == n - 1)
							a.push_back(x);
						else
							a.insert(a.begin() + i + 1, x);
						a.erase(a.begin());
						break;
					}
				}

			}
			if (x == need[cur])
				break;
		}
	}
	cout << (int)ans.size() << endl;
	for (auto &x : ans) {
		cout << x << " ";
	}
	cout << endl;
}

void solve_fir() {
	cout << n << endl;
	for (int i = 0; i < n; i++) {
		cout << n << " ";
	}
	cout << endl;
}

void solve_sec() {
	cout << 2 * n << endl;
	for (int i = 0; i < 2 * n; i++) {
		cout << n << " ";
	}
	cout << endl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n >> m;
	a.resize(n);
	need.resize(m);
	for (int &x : need) {
		cin >> x;
		x--;
	}
	for (int &x : a) {
		cin >> x;
		x--;
	}
	bool fir = n == m;
	bool sec = n == m;
	for (int i = 0; i < min(n, m); i++) {
		if (a[i] != need[i]) {
			fir = false;
		}
		if (a[i] != need[m - i - 1]) {
			sec = false;
		}
	}
	if (fir) 
		solve_fir();
	else if (sec)
		solve_sec();
	else
		solve_sq();
	//system("pause");
}