#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const long long R = 1e9 + 7;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector<vector<long long>> d(n, vector<long long>(k + 1));
	for (int i = 0; i <= k; i++) {
		d[0][i] = 1;
	}
	for (int i = 1; i < n; i++) {
		for (int j = 0; j <= k; j++) {
			for (int h = 0; h <= k; h++) {
				if ((h & j) == h) {
					d[i][j] = (d[i][j] + d[i - 1][h]) % R;
				}
			}
		}
	}
	long long ans = 0;
	for (auto &x : d[n - 1]) {
		ans += x;
	}
	cout << ans % R << endl;
	//system("pause");
}