#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const long long R = 1e9 + 7;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, k; cin >> n >> k;
	vector<vector<vector<long long>>> a(n, vector<vector<long long>>(n + 1, vector<long long>(n + 1)));
	vector<vector<vector<long long>>> b = a;
	a[0][k][k] = 1;
	b[0][k][k] = 1;
	for (int i = 1; i < n; i++) {
		for (int j = 1; j <= n; j++) {
			for (int sum = k; sum <= n; sum++) {
				for (int last = 1; last + sum <= n; last++) {
					if (last < j) {
						a[i][j][sum + last] = (a[i][j][sum + last] + b[i - 1][last][sum]) % R;
					} else {
						b[i][j][sum + last] = (b[i][j][sum + last] + a[i - 1][last][sum]) % R;
					}
				}
			}
		}
	}
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= n; j++) {
			ans += a[i][j][n] + a[i][j][n];
			ans %= R;
		}
	}
	cout << ans / 2 << endl;
	//system("pause");
}