#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
 
const long long R = 1e9 + 7;
const long long INF = 1e17;

void check(long long &a) {
	if (a >= INF)
		a %= R;
}

const int N = 503;

int solve(int n, int k) {
	long long a[2][N + 1][N + 1] = {};
	long long b[2][N + 1][N + 1] = {};
	long long pref[N + 1][N + 1] = {};
	long long suff[N + 1][N + 1] = {};
    a[1][k][k] = 1;
    b[1][k][k] = 1;
	long long ans = (n == k);
    for (int i = 0; i < n; i++) {
		if (i > 0) {
			for (int j = 1; j <= n; j++) {
				for (int sum = 0; sum + j <= n; sum++) {
					a[1][j][sum + j] += pref[j - 1][sum];
					b[1][j][sum + j] += suff[j + 1][sum];
					check(b[1][j][sum + j]);
					check(a[1][j][sum + j]);
					/*for (int last = 1; last <= n; last++) {
						if (last < j) {
							a[i][j][sum + j] = (a[i][j][sum + j] + b[i - 1][last][sum]) % R;
						} else if (last > j) {
							b[i][j][sum + j] = (b[i][j][sum + j] + a[i - 1][last][sum]) % R;
						}
					}*/
				}
			}
			for (int i = 1; i <= n; i++) {
				ans += a[1][i][n] + b[1][i][n];
				ans %= R;
			}
		}
		for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= n; j++) {
				pref[i][j] = 0;
				suff[i][j] = 0;
			}
		}
		for (int j = 1; j <= n; j++) {
			for (int sum = 0; sum <= n; sum++) {
				pref[j][sum] = pref[j - 1][sum] + b[1][j][sum];
				check(pref[j][sum]);
			}
		}
		for (int j = n; j > 0; j--) {
			for (int sum = 0; sum <= n; sum++) {
				suff[j][sum] = suff[j + 1][sum] + a[1][j][sum];
				check(suff[j][sum]);
			}
		}
		for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= n; j++) {
				a[0][i][j] = a[1][i][j];
				b[0][i][j] = b[1][i][j];
				a[1][i][j] = 0;
				b[1][i][j] = 0;
			}
		}
    }
    
	return ans;
}
 
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, k; cin >> n >> k;
	cout << solve(n, k) << endl;
   // system("pause");
}	