#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
 
const long long R = 1e9 + 7;

int solve(int n, int k) {
	vector<vector<vector<long long>>> a(n, vector<vector<long long>>(n + 2, vector<long long>(n + 2)));
    vector<vector<vector<long long>>> b = a;
	vector<vector<vector<long long>>> pref = a;
	vector<vector<vector<long long>>> suff = a;
    a[0][k][k] = 1;
    b[0][k][k] = 1;
    for (int i = 0; i < n; i++) {
		if (i > 0)
        for (int j = 1; j <= n; j++) {
            for (int sum = 0; sum + j <= n; sum++) {
				a[i][j][sum + j] = (a[i][j][sum + j] + pref[i - 1][j - 1][sum]) % R;
				b[i][j][sum + j] = (b[i][j][sum + j] + suff[i - 1][j + 1][sum]) % R;
                /*for (int last = 1; last <= n; last++) {
                    if (last < j) {
                        a[i][j][sum + j] = (a[i][j][sum + j] + b[i - 1][last][sum]) % R;
                    } else if (last > j) {
                        b[i][j][sum + j] = (b[i][j][sum + j] + a[i - 1][last][sum]) % R;
                    }
                }*/
            }
        }
		for (int j = 1; j <= n; j++) {
			for (int sum = 0; sum <= n; sum++) {
				pref[i][j][sum] = (pref[i][j - 1][sum] + b[i][j][sum]) % R;
			}
		}
		for (int j = n; j > 0; j--) {
			for (int sum = 0; sum <= n; sum++) {
				suff[i][j][sum] = (suff[i][j + 1][sum] + a[i][j][sum]) % R;
			}
		}
    }
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= n; j++) {
            ans += a[i][j][n] + b[i][j][n];
            ans %= R;
        }
    }
	return ans - (n == k);
}
 
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, k; cin >> n >> k;
	cout << solve(n, k) << endl;
   // system("pause");
}