#pragma GCC oprimize("O3")
#pragma GCC target("sse,sse2,sse3,sse4")
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
 
const long long R = 1e9 + 7;
const long long INF = 1e17;

void check(long long &a) {
	if (a >= INF)
		a %= R;
}

int solve(int n, int k) {
	vector<vector<vector<long long>>> a(2, vector<vector<long long>>(n + 2, vector<long long>(n + 2)));
    vector<vector<vector<long long>>> b = a;
	vector<vector<vector<long long>>> pref = a;
	vector<vector<vector<long long>>> suff = a;
    a[1][k][k] = 1;
    b[1][k][k] = 1;
	long long ans = (n == k);
    for (int i = 0; i < n; i++) {
		if (i > 0) {
			for (int j = 1; j <= n; j++) {
				for (int sum = 0; sum + j <= n; sum++) {
					a[1][j][sum + j] += pref[0][j - 1][sum];
					b[1][j][sum + j] += suff[0][j + 1][sum];
					check(b[1][j][sum + j]);
					check(a[1][j][sum + j]);
					/*for (int last = 1; last <= n; last++) {
						if (last < j) {
							a[i][j][sum + j] = (a[i][j][sum + j] + b[i - 1][last][sum]) % R;
						} else if (last > j) {
							b[i][j][sum + j] = (b[i][j][sum + j] + a[i - 1][last][sum]) % R;
						}
					}*/
				}
			}
			for (int i = 1; i <= n; i++) {
				ans += a[1][i][n] + b[1][i][n];
				ans %= R;
			}
		}
		pref.assign(2, vector<vector<long long>>(n + 2, vector<long long>(n + 2)));
		suff.assign(2, vector<vector<long long>>(n + 2, vector<long long>(n + 2)));
		for (int j = 1; j <= n; j++) {
			for (int sum = 0; sum <= n; sum++) {
				pref[0][j][sum] = pref[0][j - 1][sum] + b[1][j][sum];
				check(pref[0][j][sum]);
			}
		}
		for (int j = n; j > 0; j--) {
			for (int sum = 0; sum <= n; sum++) {
				suff[0][j][sum] = suff[0][j + 1][sum] + a[1][j][sum];
				check(suff[0][j][sum]);
			}
		}
		a[0] = a[1];
		b[0] = b[1];
		a[1].assign(n + 2, vector<long long>(n + 2));
		b[1].assign(n + 2, vector<long long>(n + 2));
    }
    
	return ans;
}
 
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, k; cin >> n >> k;
	cout << solve(n, k) << endl;
  // system("pause");
}	