#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

vector<vector<int>> g;

vector<bool> used;
vector<int> match;

bool kun(int v) {
	if (used[v]) {
		return false;
	}
	used[v] = true;
	for (int to : g[v]) {
		if (match[to] == -1 || kun(match[to])) {
			match[to] = v;
			return true;
		}
	}
	return false;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, k; cin >> n >> k;
	if (k == 1) {
		cout << "YES\n";
		for (int i = 0; i < n; i += 2) {
			cout << i + 1 << " " << i + 2 << "\n";
		}
		return 0;
	}
	g.resize(n);
	vector<vector<int>> a(n, vector<int>(k));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			cin >> a[i][j];
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			bool fir = true;
			bool sec = true;
			for (int h = 0; h < k; h++) {
				if (a[i][h] > a[j][h])
					fir = false;
				if (a[i][h] < a[j][h])
					sec = false;
			}
			if (fir || sec) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	match.resize(n, -1);
	for (int i = 0; i < n; i++) {
		used.assign(n, 0);
		kun(i);
	}
	used.assign(n, 0);
	vector<pair<int, int>> ans;
	for (int i = 0; i < n; i++) {
		if (match[i] != -1 && !used[i]) {
			ans.emplace_back(i, match[i]);
			used[match[i]] = true;
		}
	}
	if (ans.size() != n / 2) {
		cout << "NO\n";
		return 0;
	}
	cout << "YES\n";
	for (auto &x : ans) {
		cout << x.first + 1 << " " << x.second + 1 << "\n";
	}
	//system("pause");
}