#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const long long INF = 1e9;

int n;
int ans = 0;
vector<int> g;

void rec(int ind, vector<int> &ch, int k) {
	if (ind == n) {
		ans = max(ans, k);
		return;
	}
	rec(ind + 1, ch, k);
	if (!ch[ind] && (g[ind] == -1 || ch[g[ind]] < INF)) {
		ch[ind] = INF;
		if (g[ind] != -1) {
			ch[g[ind]]++;
		}
		rec(ind + 1, ch, k + 1);
		ch[ind] = 0;
		if (g[ind] != -1)
			ch[g[ind]]--;
	}
}

int solve_st() {
	vector<int> ch(n);
	rec(0, ch, 0);
	return ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n;
	bool fir = true;
	g.resize(n, -1);
	for (int i = 0; i < n; i++) {
		cin >> g[i];
		if (g[i] != -1)
			g[i]--;
		if (g[i] != i - 1) {
			fir = false;
		}
	}
	if (fir) {
		cout << (n + 1) / 2 << endl;
	} else {
		cout << solve_st() << endl;
	}
	//system("pause");
}